zoukankan      html  css  js  c++  java
  • HDU-1300(基础方程DP-遍历之前所有状态)

    Problem Description
    In Pearlania everybody is fond of pearls. One company, called The Royal Pearl, produces a lot of jewelry with pearls in it. The Royal Pearl has its name because it delivers to the royal family of Pearlania. But it also produces bracelets and necklaces for ordinary people. Of course the quality of the pearls for these people is much lower then the quality of pearls for the royal family. In Pearlania pearls are separated into 100 different quality classes. A quality class is identified by the price for one single pearl in that quality class. This price is unique for that quality class and the price is always higher then the price for a pearl in a lower quality class.

    Every month the stock manager of The Royal Pearl prepares a list with the number of pearls needed in each quality class. The pearls are bought on the local pearl market. Each quality class has its own price per pearl, but for every complete deal in a certain quality class one has to pay an extra amount of money equal to ten pearls in that class. This is to prevent tourists from buying just one pearl.

    Also The Royal Pearl is suffering from the slow-down of the global economy. Therefore the company needs to be more efficient. The CFO (chief financial officer) has discovered that he can sometimes save money by buying pearls in a higher quality class than is actually needed. No customer will blame The Royal Pearl for putting better pearls in the bracelets, as long as the prices remain the same.

    For example 5 pearls are needed in the 10 Euro category and 100 pearls are needed in the 20 Euro category. That will normally cost: (5+10)*10 + (100+10)*20 = 2350 Euro.

    Buying all 105 pearls in the 20 Euro category only costs: (5+100+10)*20 = 2300 Euro.

    The problem is that it requires a lot of computing work before the CFO knows how many pearls can best be bought in a higher quality class. You are asked to help The Royal Pearl with a computer program.

    Given a list with the number of pearls and the price per pearl in different quality classes, give the lowest possible price needed to buy everything on the list. Pearls can be bought in the requested, or in a higher quality class, but not in a lower one.
     
    Input
    The first line of the input contains the number of test cases. Each test case starts with a line containing the number of categories c (1 <= c <= 100). Then, c lines follow, each with two numbers ai and pi. The first of these numbers is the number of pearls ai needed in a class (1 <= ai <= 1000). The second number is the price per pearl pi in that class (1 <= pi <= 1000). The qualities of the classes (and so the prices) are given in ascending order. All numbers in the input are integers.
     
    Output
    For each test case a single line containing a single number: the lowest possible price needed to buy everything on the list.
     
    Sample Input
    2 2 100 1 100 2 3 1 10 1 11 100 12
     
    Sample Output
    330 1344
    思路:
    之前想了一种思路被验证是想偏了,后来看了正确的答案后发现和HDU的2059龟兔赛跑是同一类型的题目
    这俩题耽误了能有两天的时间,不过也算让我对DP的认识又上了一个台阶,因为他们都反映了DP的本质:一个状态的最优值是通过枚举所有能够到达这个状态的状态的值所得到的,知道了这点后,再就具体问题具体分析就OK
    下面有两段代码,前一段是是按照之前的思路做的,自己和AC的代码比对了很多组数据(故意挑了一些比较刁钻的数据)结果都是相同的,但不知道为什么还是WA,先放在这儿等以后有能力了再来解决,后面的那段代码就是AC的了。

     解法一:(WA但数据测试正确)
    #include <iostream>
    #include <cstdio>
    #include <cstring>
    using namespace std;
    
    int T;
    int number;
    struct P{
        __int64 v;
        __int64 c;
    }pearl[107];
    int exits[107];
    __int64 sum;
    
    int main()
    {
        scanf("%d",&T);
        while(T--)
        {
            sum = 0;
            scanf("%d",&number);
            for(int i = 1;i <= number;i++){
                scanf("%I64d%I64d",&pearl[i].c,&pearl[i].v);
                exits[i] = 1;
            }
            for(int i = 2;i <= number;i++)
                if(pearl[i-1].c*pearl[i].v < (pearl[i-1].c+10)*pearl[i-1].v){
                    pearl[i].c += pearl[i-1].c;
                    exits[i-1] = 0;
                }
            for(int i = 1;i <= number;i++)
                if(exits[i]) sum += (pearl[i].c+10)*pearl[i].v;
            printf("%I64d
    ",sum);
        }
        return 0;
    }

    解法二(AC):

    #include <iostream>
    #include <cstdio>
    #include <cstring>
    #define INF 0x7fffffff
    using namespace std;
    
    int min(int a,int b)
    {
        return a<b?a:b;
    }
    
    int main()
    {
        int T;
        int sum[107];
        int val[107];
        int dp[107];
        int num[107];
        scanf("%d",&T);
        while(T--)
        {
            int n;
            scanf("%d",&n);
            sum[0] = 0;
            for(int i = 1;i <= n;i++) {
                scanf("%d%d",&num[i],&val[i]);
                sum[i] = sum[i-1]+num[i];
            }
            for(int i = 1;i <= n;i++)
                dp[i] = INF;
            sum[0] = 0;
            dp[0] = 0;
            for(int i = 1;i <= n;i++) 
                for(int j = 0;j < i;j++) 
                    dp[i] = min(dp[i],dp[j]+(sum[i]-sum[j]+10)*val[i]); 
            printf("%d
    ",dp[n]);
        }
        return 0;
    }
  • 相关阅读:
    MySQL:逻辑库与表管理
    MySQL:初识数据库
    MySQL:安装与配置
    C语言之指针
    C语言之二维数组
    C语言之冒泡排序
    C语言之数组
    C语言之函数的声明
    C语言之带有返回值的函数
    C语言之全局变量和局部变量
  • 原文地址:https://www.cnblogs.com/immortal-worm/p/4929546.html
Copyright © 2011-2022 走看看